# -*- coding: utf-8 -*-
'''
    Incursion Add-on
    **Thanks bugatsinho, muad'dib, tempest, for scraper's coding tips**

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

'''

import re
from resources.lib.modules import client
from resources.lib.modules import source_utils, debrid


class source:
    def __init__(self):
        self.priority = 1
        self.language = ['en']
        self.domains = ['www.film2media.win']
        self.base_link = 'https://www.film2media.win/'
        self.search_link = '?s=%s&btnSubmit='
        self.headers = {'User-Agent': client.agent()}

    def movie(self, imdb, title, localtitle, aliases, year):
        try:
            title = title
            self.title = '%s %s' % (title, year)
            self.title = self.title.replace(':', '').replace(' - ', ' ').replace("'", "").replace('...', ' ').replace("’", "").replace('!', '')
            self.year = year
            self.imdb = imdb
            if self.imdb == 'tt7713068':
                self.title = 'Birds of Prey'
            url = self.base_link + self.search_link % self.title
            url = url.replace(' ', '%20')
            return url
        except:
            return

    def sources(self, url, hostDict, hostprDict):
        try:
            sources = []
            if debrid.status() == True: raise Exception()
            if url is None:
                return sources
            # headers = {'User-Agent': 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0'}
            r = client.request(url, headers=self.headers)
            posts = re.findall('<br><p><strong><em><a href="(.+?)" title="(.+?)" class', r)
            if posts is None:
                return sources
            for post, name in posts:
                n = name.replace('&#8217;', '').replace(':', '').replace(' - ', ' ').replace("'", "").replace('...', ' ').replace("’", "").replace('!', '')
                if not self.title.lower() in n.lower():
                    continue
                result = client.request(post, headers=self.headers)
                frames = re.findall('center;"><a href="(.+?)"', result)
                for frame in frames:
                    # f = cleantitle.get(frame).replace('%21', '').replace('%27', '').replace('%2C', '').split(self.year)[0]
                    # if not t.lower() == f.lower():
                        # continue
                    if not self.year in frame:
                        continue
                    if any (x in frame.lower() for x in ['trailer', 'extras', 'sample', '.jpg']):
                        continue
                    if not any (x in frame.lower() for x in ['.mp4', '.mkv']):
                        continue
                    frame = re.sub('s2.upload10.ir', 'dl2.upload10.ir', frame)
                    frame = re.sub('dl2.upload10.ir', 'dl2.uploadmax.ir', frame)
                    frame = re.sub('dl2.uploadmax.ir', 'v2valthw.l1wr6ke1f86v.tra97fn35n5brvxki5sj8x5x34k2t4d67j883fgt.xyz', frame)
                    frame = re.sub('v2valthw.l1wr6ke1f86v.tra97fn35n5brvxki5sj8x5x34k2t4d67j883fgt.xyz', '5f8u2z8mn5qjqvfdxs59z5g6aw8djt.w0kriscaz3hcff0sb26887827rxg7ib99m7xk9x9ikr3qil7ax59bjhogl.xyz', frame)
                    url = frame
                    host = url.split('/')[2].replace('.', '')[:7]
                    info = url.split('/')[-1]
                    quality = source_utils.check_direct_url(info)
                    sources.append({'source': host, 'quality': quality, 'language': 'en', 'url': url, 'info': info, 'direct': True, 'debridonly': False})
                    if '5f8u2z8mn5qjqvfdxs59z5g6aw8djt.w0kriscaz3hcff0sb26887827rxg7ib99m7xk9x9ikr3qil7ax59bjhogl.xyz' in frame and int(self.year) < 2020:
                        url2 = re.sub('5f8u2z8mn5qjqvfdxs59z5g6aw8djt.w0kriscaz3hcff0sb26887827rxg7ib99m7xk9x9ikr3qil7ax59bjhogl.xyz', 'm86valthw.l1wr6ke1f86v.w0kriscaz3hcff0sb26887827rxg7ib99m7xk9x9ikr3qil7ax59bjhogl.xyz', url)
                        host2 = url2.split('/')[2].replace('.', '')[:7]
                        sources.append({'source': host2, 'quality': quality, 'language': 'en', 'url': url2, 'info': info, 'direct': True, 'debridonly': False})
            return sources
        except:
            return sources

    def resolve(self, url):
        return url
