# -*- coding: utf-8 -*-
'''
    Incursion Add-on
    **Thanks bugatsinho, muad'dib, tempest, for scraper's coding tips**

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

'''

import re
import urlparse
from resources.lib.modules import client
from resources.lib.modules import source_utils, debrid


class source:
    def __init__(self):
        self.priority = 1
        self.language = ['en']
        self.domains = ['www.film2serial.ir']
        self.base_link = 'https://www.film2serial.ir/'
        self.search_link = '?s=%s'
        self.headers = {'User-Agent': client.agent()}

    def movie(self, imdb, title, localtitle, aliases, year):
        try:
            title = title
            self.title = title
            self.title = self.title.replace(':', '').replace(' - ', ' ').replace("'", "").replace('...', ' ').replace("’", "").replace('!', '')
            self.year = year
            self.imdb = imdb
            if self.imdb == 'tt7713068':
                self.title = 'Birds of Prey'
            url = self.base_link + self.search_link % self.title
            url = url.replace(' ', '%20')
            return url
        except:
            return

    def sources(self, url, hostDict, hostprDict):
        try:
            sources = []
            if debrid.status() == True: raise Exception()
            if url is None:
                return sources
            r = client.request(url, headers=self.headers)
            data = client.parseDOM(r, 'div class="post"')
            for item in data:
                try:
                    post = client.parseDOM(item, 'a', ret='href', attrs={'rel': 'bookmark'})[0]
                except:
                    continue
                try:
                    name = client.parseDOM(item, 'a', ret='title', attrs={'rel': 'bookmark'})[0]
                except:
                    continue
                name = client.replaceHTMLCodes(name)
                n = re.sub(r'[^\w]', '', name)
                t = self.title
                t1 = re.sub(r'[^\w]', '', t)
                t2 = '%s%s' % (t1, self.year)
                t3 = '%s%s' % (self.year, t1)
                if not t1.lower() == n.lower() and not t2.lower() == n.lower() and not t3.lower() == n.lower() and not self.imdb in item:
                    continue
                result = client.request(post, headers=self.headers)
                frames = client.parseDOM(result, 'a', ret='href', attrs={'rel': 'noopener noreferrer'})
                for frame in frames:
                    if any(x in frame.lower() for x in ['trailer', 'extras', 'sample', '.jpg', '.mka']):
                        continue
                    if not any(x in frame.lower() for x in ['.mp4', '.mkv']):
                        continue
                    url = frame
                    host = url.split('/')[2].replace('.', '')[:7]
                    info = url.split('/')[-1]
                    quality = source_utils.check_direct_url(info)
                    info = '{0} | GKoBu'.format(info)
                    sources.append({'source': host, 'quality': quality, 'language': 'en', 'url': url, 'info': info, 'direct': True, 'debridonly': False})
            return sources
        except:
            return sources

    def resolve(self, url):
        return url
