# -*- coding: UTF-8 -*-
'''
    Incursion Add-on
    **Thanks bugatsinho, muad'dib, tempest, for scraper's coding tips**

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

'''
import re
import urllib
import urlparse

from resources.lib.modules import client, source_utils, debrid


class source:
    def __init__(self):
        self.priority = 1
        self.language = ['en']
        self.domains = ['hymvz.fun']
        self.base_link = 'https://hymvz.fun/'
        self.search_link = '?s=%s'
        self.headers = {'User-Agent': client.agent()}

    def tvshow(self, imdb, tvdb, tvshowtitle, localtvshowtitle, aliases, year):
        try:
            tvshowtitle = tvshowtitle.replace(':', '').replace(' - ', ' ').replace("'", "").replace("’", "")
            title = tvshowtitle
            url = {'tvshowtitle': title}
            url = urllib.urlencode(url)
            return url
        except Exception:
            return

    def episode(self, url, imdb, tvdb, title, premiered, season, episode):
        try:
            url = urlparse.parse_qs(url)
            url = dict([(i, url[i][0]) if url[i] else (i, '') for i in url])
            url['season'], url['episode'], url['imdb'] = season, episode, imdb
            url = urllib.urlencode(url)
            return url
        except Exception:
            return

    def sources(self, url, hostDict, hostprDict):
        try:
            sources = []
            if debrid.status() == True: raise Exception()

            if url is None:
                return sources

            data = urlparse.parse_qs(url)
            data = dict([(i, data[i][0]) if data[i] else (i, '') for i in data])
            hldr = 'S%02dE%02d' % (int(data['season']), int(data['episode']))
            hldr2 = 'S%02d.E%02d' % (int(data['season']), int(data['episode']))
            season = ['S%02d' % int(data['season']), 'S%d' % int(data['season']), 'season-%d' % int(data['season']), 'season %d' % int(data['season']), 'season%s%d' % ('%20', int(data['season']))]
            title = data['tvshowtitle']
            imdbid = data['imdb']

            url = urlparse.urljoin(self.base_link, self.search_link % title)
            url = url.replace(' ' ,'%20')
            r = client.request(url, headers=self.headers)
            sdata = client.parseDOM(r, 'div class="col-6 col-md-6 col-lg-4 col-xl-3"')
            for item in sdata:
                try:
                    post = client.parseDOM(item, 'a', ret='href', attrs={'class': 'd-block position-relative'})[0]
                except:
                    continue
                try:
                    name = client.parseDOM(item, 'a', ret='title', attrs={'class': 'd-block position-relative'})[0]
                except:
                    continue
                name = client.replaceHTMLCodes(name)
                n = re.sub(r'[^\w]', '', name)
                n = re.sub(r'\d{4}$', '', n)
                t = title
                t1 = re.sub(r'[^\w]', '', t)
                if not imdbid in item and not t1.lower() == n.lower():
                    continue
                result = client.request(post, headers=self.headers)
                results = client.parseDOM(result, 'a', ret='href', attrs={'class': 'd-inline-block h_f_bold pr-3 pl-3'})
                for link in results:
                    if hldr.lower() in link.lower() or hldr2.lower() in link.lower():
                        if any(x in link.lower() for x in ['trailer', 'extras', 'sample', '.jpg', '.mka']):
                            continue
                        if not any(x in link.lower() for x in ['.mp4', '.mkv']):
                            continue
                        link = link.replace(' ', '%20')
                        host = link.split('/')[2].replace('.', '')[:7]
                        info = link.split('/')[-1]
                        quality = source_utils.check_direct_url(info)
                        info = '{0} | GKoBu'.format(info)
                        sources.append({'source': host, 'quality': quality, 'language': 'en',
                                        'url': link, 'info': info, 'direct': True, 'debridonly': False})
            return sources
        except Exception:
            return sources

    def resolve(self, url):
        return url

