# -*- coding: utf-8 -*-
'''
    Incursion Add-on
    **Thanks bugatsinho, muad'dib, tempest, for scraper's coding tips**

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

'''

import re, urllib
from resources.lib.modules import source_utils, debrid
from resources.lib.modules import client


class source:
    def __init__(self):
        self.priority = 1
        self.language = ['en']
        self.domains = ['playstop.ir']
        self.base_link = 'https://playstop.ir/'
        self.search_link = 'search/%s'
        self.headers = {'User-Agent': client.agent()}

    def movie(self, imdb, title, localtitle, aliases, year):
        try:
            title = title
            self.title = title
            self.title = self.title.replace(':', '').replace(' - ', ' ').replace("'", "").replace('...', ' ').replace("’", "").replace('!', '')
            self.year = year
            self.imdb = imdb
            if self.imdb == 'tt7713068':
                self.title = 'Birds of Prey'
            if self.imdb == 'tt2850386':
                self.title = 'The Croods 2'
            url = self.base_link + self.search_link % self.imdb
            url = url.replace(' ', '+')
            return url
        except:
            return

    def sources(self, url, hostDict, hostprDict):
        try:
            sources = []
            if debrid.status() == True: raise Exception()
            if url is None:
                return sources
            r = client.request(url, headers=self.headers)
            data = client.parseDOM(r, 'article class="big_post"')
            if len(data) < 1:
                t = '%s+%s' % (self.title, self.year)
                url = self.base_link + self.search_link % t
                url = url.replace(' ', '+')
                r = client.request(url, headers=self.headers)
                data = client.parseDOM(r, 'article class="big_post"')
            for item in data:
                posts = re.findall('<h2><a href="(.+?)" title="(.+?)"', item, re.DOTALL)
                if posts is None:
                    return sources
                for post, name in posts:
                    n = re.sub(r'[^\w]', '', name)
                    t = self.title
                    t1 = re.sub(r'[^\w]', '', t)
                    t2 = '%s%s' % (t1, self.year)
                    t3 = '%s%s' % (self.year, t1)
                    if not t1.lower() == n.lower() and not t2.lower() == n.lower() and not t3.lower() == n.lower():
                        continue
                    result = client.request(post, headers=self.headers)
                    results = client.parseDOM(result, 'ul class="movie_download"')
                    for frames in results:
                        frame = client.parseDOM(frames, 'li')
                        for links in frame:
                            try:
                                link = re.findall('<a class="link" href="(.+?)"', links, re.DOTALL)[0]
                            except:
                                continue
                            if any (x in link.lower() for x in ['trailer', 'extras', 'sample', '.jpg', 'upera.tv', 'duble']):
                                continue
                            if not any (x in link.lower() for x in ['.mp4', '.mkv']):
                                continue
                            url = link
                            host = url.split('/')[2].replace('.', '')[:7]
                            info = url.split('/')[-1]
                            quality = source_utils.check_direct_url(info)
                            try:
                                size = re.findall('<span class="ssize">(.+?)</span>', links, re.DOTALL)[0]
                                size = size.replace('حجم :'.encode('utf-8'), '').replace('مگابایت'.encode('utf-8'), 'MB').replace('گیگابایت'.encode('utf-8'), 'GB')
                            except:
                                size = '0'
                            if not size == '0':
                                info = '{0} | {1} | GKoBu'.format(size, info)
                            else:
                                info = '{0} | GKoBu'.format(info)
                            url += '|User-Agent=%s&Referer=%s' % (urllib.quote(client.agent()), url)
                            sources.append({'source': host, 'quality': quality, 'language': 'en', 'url': url, 'info': info, 'direct': True, 'debridonly': False})
            return sources
        except:
            return sources

    def resolve(self, url):
        return url
