# -*- coding: utf-8 -*-
'''
    Incursion Add-on
    **Thanks bugatsinho, muad'dib, tempest, for scraper's coding tips**

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

'''

import re, urllib
from resources.lib.modules import client
from resources.lib.modules import source_utils, debrid


class source:
    def __init__(self):
        self.priority = 1
        self.language = ['en']
        self.domains = ['zarfilm.casa']
        self.base_link = 'https://zarfilm.casa/'
        self.search_link = '%s/'
        self.headers = {'User-Agent': client.agent()}

    def movie(self, imdb, title, localtitle, aliases, year):
        try:
            title = title
            self.title = '%s %s' % (title, year)
            self.title = self.title.replace(':', '').replace(' - ', ' ').replace("'", "").replace('...', ' ').replace("’", "").replace('!', '')
            self.year = year
            self.imdb = imdb
            if self.imdb == 'tt7713068':
                self.title = 'Birds of Prey 2020'
            url = self.base_link + self.search_link % self.imdb
            url = url.replace(' ', '%20')
            return url
        except:
            return

    def sources(self, url, hostDict, hostprDict):
        try:
            sources = []
            if debrid.status() == True: raise Exception()
            if url is None:
                return sources
            r = client.request(url, headers=self.headers)
            data = client.parseDOM(r, 'div class="collapse siteSingle__boxContent__download"')
            for item in data:
                item = item.replace('گیگابایت'.encode('utf-8'), 'GB').replace('مگابایت'.encode('utf-8'), 'MB')
                try:
                    size = re.findall('<span>(\d+.\d+\s*M|\d+\s*M|\d+.\d+\s*G|\d+\s*G|\d+.\d+\s*MB|\d+\s*MB|\d+.\d+\s*GB|\d+\s*GB|\d+.\d+\s*MiB|\d+\s*MiB|\d+.\d+\s*GiB|\d+\s*GiB)</span>', item, re.DOTALL)[0]
                except:
                    size = '0'
                try:
                    link = client.parseDOM(item, 'a', ret='href', attrs={'class': 'siteSingle__boxContent__downloadContent__link'})[0]
                except:
                    continue
                if any (x in link.lower() for x in ['trailer', 'extras', 'sample', '.jpg', '.mka']):
                    continue
                if not any (x in link.lower() for x in ['.mp4', '.mkv']):
                    continue
                url = link
                host = url.split('/')[2].replace('.', '')[:7]
                info = url.split('/')[-1]
                quality = source_utils.check_direct_url(info)
                if not size == '0':
                    size = size.lower().replace('gib', 'gb').replace('mib', 'mb').replace('مگابایت'.encode('utf-8'), 'MB').replace('گیگابایت'.encode('utf-8'), 'GB')
                    if 'mb' not in size.lower() and 'gb' not in size.lower():
                        size = size.lower().replace('g', 'gb').replace('m', 'mb')
                    info = ('{0} | {1} | GKoBu').format(size, info)
                else:
                    info = '{0} | GKoBu'.format(info)
                url += '|User-Agent=%s&Referer=%s' % (urllib.quote(client.agent()), url)
                sources.append({'source': host, 'quality': quality, 'language': 'en', 'url': url, 'info': info, 'direct': True, 'debridonly': False})
            return sources
        except:
            return sources

    def resolve(self, url):
        return url
