# -*- coding: UTF-8 -*-
'''
    Incursion Add-on
    **Thanks bugatsinho, muad'dib, tempest, for scraper's coding tips**

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

'''
import re
import urllib
import urlparse

from resources.lib.modules import client, source_utils, debrid


class source:
    def __init__(self):
        self.priority = 1
        self.language = ['en']
        self.domains = ['zarfilm.casa']
        self.base_link = 'https://zarfilm.casa/'
        self.search_link = 'series/%s/'
        self.headers = {'User-Agent': client.agent()}

    def tvshow(self, imdb, tvdb, tvshowtitle, localtvshowtitle, aliases, year):
        try:
            tvshowtitle = tvshowtitle.replace(':', '').replace(' - ', ' ').replace("'", "").replace("’", "")
            title = tvshowtitle
            url = {'tvshowtitle': title}
            url = urllib.urlencode(url)
            return url
        except Exception:
            return

    def episode(self, url, imdb, tvdb, title, premiered, season, episode):
        try:
            self.imdb = imdb
            url = urlparse.parse_qs(url)
            url = dict([(i, url[i][0]) if url[i] else (i, '') for i in url])
            url['season'], url['episode'] = season, episode
            url = urllib.urlencode(url)
            return url
        except Exception:
            return

    def sources(self, url, hostDict, hostprDict):
        try:
            sources = []
            if debrid.status() == True: raise Exception()

            if url is None:
                return sources

            data = urlparse.parse_qs(url)
            data = dict([(i, data[i][0]) if data[i] else (i, '') for i in data])
            hldr = 'S%02dE%02d' % (int(data['season']), int(data['episode']))
            season = ['S%02d' % int(data['season']), 'season-%d' % int(data['season']), 'season %d' % int(data['season'])]
            title = data['tvshowtitle']

            url = urlparse.urljoin(self.base_link, self.search_link % self.imdb)
            url = url.replace(' ' ,'%20')
            r = client.request(url, headers=self.headers)
            posts = client.parseDOM(r, 'a', ret='href', attrs={'class': 'siteSingle__boxContent__serialContent__downloadLink'})
            if posts is None:
                return sources
            for dirlink in posts:
                if hldr.lower() in dirlink.lower():
                    link = dirlink
                    host = link.split('/')[2].replace('.', '')[:7]
                    info = link.split('/')[-1]
                    quality = source_utils.check_direct_url(info)
                    info = '{0} | GKoBu'.format(info)
                    link += '|User-Agent=%s&Referer=%s' % (urllib.quote(client.agent()), link)
                    sources.append({'source': host, 'quality': quality, 'language': 'en',
                                    'url': link, 'info': info, 'direct': True, 'debridonly': False})
            return sources
        except Exception:
            return sources

    def resolve(self, url):
        return url

