# -*- coding: UTF-8 -*-
"""
    Incursion Add-on
    **Thanks bugatsinho, muad'dib, tempest, for scraper's coding tips**

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

"""
import re, urllib, urlparse
from resources.lib.modules import client, source_utils, debrid

class source:

    def __init__(self):
        self.priority = 1
        self.language = ['en']
        self.domains = ['actmovie.xyz']
        self.base_link = 'https://actmovie.xyz/'
        self.search_link = '?s=%s'
        self.headers = {'User-Agent': client.agent()}

    def tvshow(self, imdb, tvdb, tvshowtitle, localtvshowtitle, aliases, year):
        try:
            tvshowtitle = tvshowtitle.replace(':', '').replace(' - ', ' ').replace("'", '').replace("’", '')
            title = tvshowtitle
            url = {'tvshowtitle': title}
            url = urllib.urlencode(url)
            return url
        except Exception:
            return

    def episode(self, url, imdb, tvdb, title, premiered, season, episode):
        try:
            url = urlparse.parse_qs(url)
            url = dict([ (i, url[i][0]) if url[i] else (i, '') for i in url ])
            url['season'], url['episode'], url['imdb'] = season, episode, imdb
            url = urllib.urlencode(url)
            return url
        except Exception:
            return

    def sources(self, url, hostDict, hostprDict):
        try:
            sources = []
            if debrid.status() == True:
                raise Exception()
            if url is None:
                return sources
            data = urlparse.parse_qs(url)
            data = dict([ (i, data[i][0]) if data[i] else (i, '') for i in data ])
            hldr = 'S%02dE%02d' % (int(data['season']), int(data['episode']))
            hldr2 = 'S%02d.E%02d' % (int(data['season']), int(data['episode']))
            season = ['S%02d' % int(data['season']), 'season-%d' % int(data['season']), 'season %d' % int(data['season'])]
            title = data['tvshowtitle']
            imdbid = data['imdb']

            url = urlparse.urljoin(self.base_link, self.search_link % title)
            url = url.replace(' ', '%20')
            r = client.request(url, headers=self.headers)
            postdata = client.parseDOM(r, 'div class="post-title-flex"')
            if postdata is None:
                return sources

            for post in postdata:
                if not imdbid in post:
                    continue
                postlink = client.parseDOM(post, 'a', ret='href', attrs={'data-wpel-link': 'internal'})[0]
                result = client.request(postlink, headers=self.headers)
                sdata = client.parseDOM(result, 'li class="file"')
                for item in sdata:
                    item = item.replace('\n', '')
                    try:
                        dlink = client.parseDOM(item, 'li class="download"')[0]
                        dirlink = client.parseDOM(dlink, 'a', ret='href')[0]
                    except:
                        continue
                    if dirlink.endswith('/'):
                        if [ i for e in season if e.lower() in dirlink.lower() ]:
                            result2 = client.request(dirlink, headers=self.headers)
                            results2 = re.findall('class="na" href="(.+?)">.+?<td class="s">(.+?)</td>', result2, re.DOTALL)
                            for link, size in results2:
                                if link.startswith('.') or link.startswith('?'):
                                    continue
                                if hldr.lower() in link.lower() or hldr2.lower() in link.lower():
                                    link = urlparse.urljoin(dirlink, link)
                                    if any(x in link.lower() for x in ['trailer', 'extras', 'sample', '.jpg', 'subfa']):
                                        continue
                                    if not any(x in link.lower() for x in ['.mp4', '.mkv']):
                                        continue
                                    host = link.split('/')[2].replace('.', '')[:7]
                                    info = link.split('/')[(-1)]
                                    quality = source_utils.check_direct_url(info)
                                    if not size == '0':
                                        size = size.lower().replace('gib', 'gb').replace('mib', 'mb')
                                        if 'mb' not in size.lower() and 'gb' not in size.lower():
                                            size = size.lower().replace('g', 'gb').replace('m', 'mb')
                                        info = ('{0} | {1} | GKoBu').format(size, info)
                                    else:
                                        info = '{0} | GKoBu'.format(info)
                                    link += '|User-Agent=%s&Referer=%s' % (urllib.quote(client.agent()), link)
                                    sources.append({'source': host, 'quality': quality, 'language': 'en', 'url': link, 
                                       'info': info, 'direct': True, 'debridonly': False})

                    if hldr.lower() in dirlink.lower() or hldr2.lower() in dirlink.lower():
                        if any(x in dirlink.lower() for x in ['trailer', 'extras', 'sample', '.jpg']):
                            continue
                        if not any(x in dirlink.lower() for x in ['.mp4', '.mkv']):
                            continue
                        link = dirlink
                        host = link.split('/')[2].replace('.', '')[:7]
                        info = link.split('/')[(-1)]
                        quality = source_utils.check_direct_url(info)
                        info = '{0} | GKoBu'.format(info)
                        link += '|User-Agent=%s&Referer=%s' % (urllib.quote(client.agent()), link)
                        sources.append({'source': host, 'quality': quality, 'language': 'en', 'url': link, 
                           'info': info, 'direct': True, 'debridonly': False})

            return sources
        except Exception:
            return sources

        return

    def resolve(self, url):
        return url