# -*- coding: UTF-8 -*-
'''
    Incursion Add-on
    **Thanks bugatsinho, muad'dib, tempest, for scraper's coding tips**

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

'''
import re
import urllib
import urlparse

from resources.lib.modules import client, source_utils, debrid


class source:
    def __init__(self):
        self.priority = 1
        self.language = ['en']
        self.domains = ['filmin.info']
        self.base_link = 'https://filmin.info/'
        self.search_link = '?s=%s'
        self.headers = {'User-Agent': client.agent()}

    def tvshow(self, imdb, tvdb, tvshowtitle, localtvshowtitle, aliases, year):
        try:
            tvshowtitle = tvshowtitle.replace(':', '').replace(' - ', ' ').replace("'", "").replace("’", "")
            title = tvshowtitle
            url = {'tvshowtitle': title}
            url = urllib.urlencode(url)
            return url
        except Exception:
            return

    def episode(self, url, imdb, tvdb, title, premiered, season, episode):
        try:
            self.imdb = imdb
            url = urlparse.parse_qs(url)
            url = dict([(i, url[i][0]) if url[i] else (i, '') for i in url])
            url['season'], url['episode'] = season, episode
            url = urllib.urlencode(url)
            return url
        except Exception:
            return

    def sources(self, url, hostDict, hostprDict):
        try:
            sources = []
            if debrid.status() == True: raise Exception()

            if url is None:
                return sources

            data = urlparse.parse_qs(url)
            data = dict([(i, data[i][0]) if data[i] else (i, '') for i in data])
            hldr = 'S%02dE%02d' % (int(data['season']), int(data['episode']))
            hldr2 = 'S%02d.E%02d' % (int(data['season']), int(data['episode']))
            season = ['S%02d' % int(data['season']), 'S%d' % int(data['season']), 'season-%d' % int(data['season']), 'season %d' % int(data['season']), 'season%s%d' % ('%20', int(data['season']))]
            title = data['tvshowtitle']

            url = urlparse.urljoin(self.base_link, self.search_link % title)
            url = url.replace(' ' ,'%20')
            r = client.request(url, headers=self.headers)
            sdata = client.parseDOM(r, 'h2', attrs={'class': 'entry-title'})
            for item in sdata:
                item = item.replace('\n', '')
                posts = re.findall('<a href="(.+?)" rel="bookmark" data-wpel-link="internal">(.+?)</a>', item, re.DOTALL)
                for post, name in posts:
                    n = client.replaceHTMLCodes(name)
                    n = re.sub(r'[^\w]', '', n)
                    t = re.sub(r'[^\w]', '', title)
                    if not self.imdb in item and not t.lower() == n.lower():
                        continue
                    result = client.request(post, headers=self.headers)
                    results = client.parseDOM(result, 'a', ret='href', attrs={'class': 'fasc-button fasc-size-small fasc-type-flat fasc-style-bold'})
                    for dirlink in results:
                        if len(sources) >= 2:
                            continue
                        if 'dubbed' in dirlink.lower():
                            continue
                        if not dirlink.startswith('http://') and not dirlink.startswith('https://'):
                            dirlink = dirlink.replace('http:', 'http://').replace('https:', 'https://')
                        if not dirlink.endswith('.mkv') and not dirlink.endswith('.mp4') and not [ i for e in season if e.lower() in dirlink.lower() ]:
                            continue
                        if not dirlink.endswith('.mkv') and not dirlink.endswith('.mp4') and [ i for e in season if e.lower() in dirlink.lower() ]:
                            dirlink = dirlink + '/'
                            result2 = client.request(dirlink, headers=self.headers)
                            results2 = client.parseDOM(result2, 'li')
                            for frame in results2:
                                try:
                                    dname = client.parseDOM(frame, 'a', ret='data-name', attrs={'class': 'clearfix'})[0]
                                except:
                                    continue
                                try:
                                    link = client.parseDOM(frame, 'a', ret='href', attrs={'class': 'clearfix'})[0]
                                except:
                                    continue
                                try:
                                    size = client.parseDOM(frame, 'span', attrs={'class': 'file-size col-md-2 col-sm-2 col-xs-3 text-right'})[0]
                                    size = re.findall('(\d+.\d+\s*M|\d+\s*M|\d+.\d+\s*G|\d+\s*G|\d+.\d+\s*MB|\d+\s*MB|\d+.\d+\s*GB|\d+\s*GB|\d+.\d+\s*MiB|\d+\s*MiB|\d+.\d+\s*GiB|\d+\s*GiB)', size, re.DOTALL)[0]
                                except:
                                    size = '0'
                                if dname.startswith('.') or dname.startswith('?'):
                                    continue
                                sublink = urlparse.urljoin(dirlink, link)
                                if not link.endswith('.mkv') and not link.endswith('.mp4'):
                                    subhtml = client.request(sublink, headers=self.headers)
                                    subres = client.parseDOM(subhtml, 'li')
                                    for newframe in subres:
                                        try:
                                            sdname = client.parseDOM(newframe, 'a', ret='data-name', attrs={'class': 'clearfix'})[0]
                                        except:
                                            continue
                                        try:
                                            slink = client.parseDOM(newframe, 'a', ret='href', attrs={'class': 'clearfix'})[0]
                                        except:
                                            continue
                                        try:
                                            size = client.parseDOM(newframe, 'span', attrs={'class': 'file-size col-md-2 col-sm-2 col-xs-3 text-right'})[0]
                                            size = re.findall('(\d+.\d+\s*M|\d+\s*M|\d+.\d+\s*G|\d+\s*G|\d+.\d+\s*MB|\d+\s*MB|\d+.\d+\s*GB|\d+\s*GB|\d+.\d+\s*MiB|\d+\s*MiB|\d+.\d+\s*GiB|\d+\s*GiB)', size, re.DOTALL)[0]
                                        except:
                                            size = '0'
                                        if sdname.startswith('.') or sdname.startswith('?'):
                                            continue
                                        if hldr.lower() in slink.lower() or hldr2.lower() in slink.lower():
                                            nlink = urlparse.urljoin(sublink, slink)
                                            host = nlink.split('/')[2].replace('.', '')[:7]
                                            info = nlink.split('/')[-1]
                                            if not size == '0':
                                                size = size.lower().replace('gib', 'gb').replace('mib', 'mb')
                                                if 'mb' not in size.lower() and 'gb' not in size.lower():
                                                    size = size.lower().replace('g', 'gb').replace('m', 'mb')
                                                info = ('{0} | {1} | GKoBu').format(size, info)
                                            else:
                                                info = '{0} | GKoBu'.format(info)
                                            quality = source_utils.check_direct_url(info)
                                            # nlink += '|User-Agent=%s&Referer=%s' % (urllib.quote(client.agent()), nlink)
                                            sources.append({'source': host, 'quality': quality, 'language': 'en',
                                                            'url': nlink, 'info': info, 'direct': True, 'debridonly': False})
                                if hldr.lower() in link.lower() or hldr2.lower() in link.lower():
                                    host = sublink.split('/')[2].replace('.', '')[:7]
                                    info = sublink.split('/')[-1]
                                    if not size == '0':
                                        size = size.lower().replace('gib', 'gb').replace('mib', 'mb')
                                        if 'mb' not in size.lower() and 'gb' not in size.lower():
                                            size = size.lower().replace('g', 'gb').replace('m', 'mb')
                                        info = ('{0} | {1} | GKoBu').format(size, info)
                                    else:
                                        info = '{0} | GKoBu'.format(info)
                                    quality = source_utils.check_direct_url(info)
                                    # sublink += '|User-Agent=%s&Referer=%s' % (urllib.quote(client.agent()), sublink)
                                    sources.append({'source': host, 'quality': quality, 'language': 'en',
                                                    'url': sublink, 'info': info, 'direct': True, 'debridonly': False})
                        if hldr.lower() in dirlink.lower() or hldr2.lower() in dirlink.lower():
                            link = dirlink
                            host = link.split('/')[2].replace('.', '')[:7]
                            info = link.split('/')[-1]
                            quality = source_utils.check_direct_url(info)
                            info = '{0} | GKoBu'.format(info)
                            # link += '|User-Agent=%s&Referer=%s' % (urllib.quote(client.agent()), link)
                            sources.append({'source': host, 'quality': quality, 'language': 'en',
                                            'url': link, 'info': info, 'direct': True, 'debridonly': False})
            return sources
        except Exception:
            return sources

    def resolve(self, url):
        return url

