# -*- coding: utf-8 -*-
'''
    Incursion Add-on
    **Thanks bugatsinho, muad'dib, tempest, for scraper's coding tips**

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

'''

import re
from resources.lib.modules import cleantitle, client
from resources.lib.modules import source_utils, debrid


class source:
    def __init__(self):
        self.priority = 1
        self.language = ['en']
        self.domains = ['karanmovie.org']
        self.base_link = 'https://karanmovie.org/'
        self.search_link = 'search/%s/feed/rss2/'
        self.headers = {'User-Agent': client.agent()}

    def movie(self, imdb, title, localtitle, aliases, year):
        try:
            title = title
            self.title = '%s %s' % (title, year)
            self.title = self.title.replace(':', '').replace(' - ', ' ').replace("'", "").replace('...', ' ').replace("’", "").replace('!', '')
            self.year = year
            self.imdb = imdb
            if self.imdb == 'tt7713068':
                self.title = 'Birds of Prey'
            url = self.base_link + self.search_link % self.title
            url = url.replace(' ', '+')
            return url
        except:
            return

    def sources(self, url, hostDict, hostprDict):
        try:
            sources = []
            if debrid.status() == True: raise Exception()
            if url is None:
                return sources
            # headers = {'User-Agent': 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0'}
            r = client.request(url, headers=self.headers)
            data = client.parseDOM(r, 'item')
            for item in data:
                try:
                    moviename = client.parseDOM(item, 'title')[0]
                    if not self.title.lower() in str(moviename).lower():
                        continue
                    frames = re.findall('<enclosure url="(.+?)" length="(.+?)" type="video', item)
                    for frame, size in frames:
                        # f = cleantitle.get(frame).replace('%21', '').replace('%27', '').replace('%2C', '').split(self.year)[0]
                        # if not t.lower() == f.lower():
                            # continue
                        if not self.year in frame:
                            continue
                        if any (x in frame.lower() for x in ['trailer', 'extras', 'sample', '.jpg']):
                            continue
                        if not any (x in frame.lower() for x in ['.mp4', '.mkv']):
                            continue
                        url = frame
                        host = url.split('/')[2].replace('.', '')[:7]
                        file = url.split('/')[-1]
                        quality = source_utils.check_direct_url(file)
                        try:
                            size = source_utils.convert_size(int(size))
                            info = file
                            if size is not None:
                                info = '{0} | {1}'.format(size, info)
                        except:
                            info = file
                        sources.append({'source': host, 'quality': quality, 'language': 'en', 'url': url, 'info': info, 'direct': True, 'debridonly': False})
                except: pass
            return sources
        except:
            return sources

    def resolve(self, url):
        return url
