# -*- coding: UTF-8 -*-
'''
    Incursion Add-on
    **Thanks bugatsinho, muad'dib, tempest, for scraper's coding tips**

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

'''
import re
import urllib
import urlparse

from resources.lib.modules import client, source_utils, debrid


class source:
    def __init__(self):
        self.priority = 1
        self.language = ['en']
        self.domains = ['moviessquad.com']
        self.base_link = 'https://moviessquad.com/'
        self.search_link = 'episodes/%s-%s/'
        self.headers = {'User-Agent': client.agent()}

    def tvshow(self, imdb, tvdb, tvshowtitle, localtvshowtitle, aliases, year):
        try:
            tvshowtitle = tvshowtitle.replace(':', '').replace(' - ', ' ').replace("'", "").replace("’", "")
            title = tvshowtitle
            url = {'tvshowtitle': title}
            url = urllib.urlencode(url)
            return url
        except Exception:
            return

    def episode(self, url, imdb, tvdb, title, premiered, season, episode):
        try:
            url = urlparse.parse_qs(url)
            url = dict([(i, url[i][0]) if url[i] else (i, '') for i in url])
            url['season'], url['episode'] = season, episode
            url = urllib.urlencode(url)
            return url
        except Exception:
            return

    def sources(self, url, hostDict, hostprDict):
        try:
            sources = []
            if debrid.status() == True: raise Exception()

            if url is None:
                return sources

            data = urlparse.parse_qs(url)
            data = dict([(i, data[i][0]) if data[i] else (i, '') for i in data])
            hldr = 'S%02dE%02d' % (int(data['season']), int(data['episode']))
            season = ['S%02d' % int(data['season']), 'season-%d' % int(data['season']), 'season %d' % int(data['season'])]
            title = data['tvshowtitle']
            ep = '%dx%d' % (int(data['season']), int(data['episode']))
            tvt = title.lower().replace(' ' ,'-')

            url = urlparse.urljoin(self.base_link, self.search_link % (tvt, ep))
            r = client.request(url, headers=self.headers)
            links = re.findall("<a href='(https://moviessquad.com/links/.+?)'", r, re.DOTALL)
            for link in links:
                rlink = client.request(link, headers=self.headers)
                eplinks = re.findall('<a id="link" rel="nofollow" href="(.+?)"', rlink, re.DOTALL)
                for eplink in eplinks:
                    url = eplink.replace('/1:/' ,'/0:/')
                    host = url.split('/')[2].replace('.', '')[:7]
                    info = url.split('/')[-1]
                    quality = source_utils.check_direct_url(info)
                    if host == 'tdmovie':
                        host = 'DL'
                        # url += '|User-Agent=%s&Referer=%s' % (urllib.quote(client.agent()), url)
                        sources.append({'source': host, 'quality': quality, 'language': 'en', 'url': url, 'info': info, 'direct': True, 'debridonly': False})
                    else:
                        sources.append({'source': host, 'quality': '720P', 'language': 'en', 'url': url, 'info': info, 'direct': False, 'debridonly': False})
            return sources
        except Exception:
            return sources

    def resolve(self, url):
        return url

